/**
 * @file  sci.c
 * @brief SCIhCo
 *
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)`(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copyright (C) Hokuto denshi Co,Ltd. 2016
 */

#define ERROR	-1
#define NOERROR	0

/*----------------------------------------------------------------------
	CN[h
----------------------------------------------------------------------*/
#include	<machine.h>
#include	"iodefine.h"
#include	"sci.h"
#include	"r_cg_userdefine.h"

/*----------------------------------------------------------------------
	萔`
----------------------------------------------------------------------*/


/*----------------------------------------------------------------------
	vg^Cv錾
----------------------------------------------------------------------*/
static void sci_init_port( void );
static void sci_wait( unsigned long msec );

void sciInit( void );
char sciRead( void );
void sciWrite( unsigned char Buffer );
void sciPrint( char *Buffer );
void sciPrintByte( unsigned char dmy );
void sciPrintWord( unsigned short dmy );
void sciPrintDword( unsigned long dmy );
void sciPrintByteInt( unsigned char dmy );
void sciPrintShortInt( unsigned short dmy );

void sciWriteBuf( unsigned char Buffer );
void sciPrintBuf( char *Buffer );
void sciPrintByteBuf( unsigned char dmy );
void sciPrintWordBuf( unsigned short dmy );
void sciPrintDwordBuf( unsigned long dmy );
void sciPrintByteIntBuf( unsigned char dmy );
void sciPrintShortIntBuf( unsigned short dmy );

/*----------------------------------------------------------------------
	O[oϐit@Cj
----------------------------------------------------------------------*/
static const char disp_table[] = "0123456789ABCDEF";		// e[u

unsigned char g_sci_rxi_flag;
unsigned char g_sci_txi_flag;
unsigned char g_sci_err_flag;

unsigned char g_sci_buf[SCI_BUF_SIZE];
unsigned short g_sci_buf_wp=0;
unsigned short g_sci_buf_rp=0;


/*----------------------------------------------------------------------
	\[XR[h
----------------------------------------------------------------------*/
/** |[g֐
 * @param void
 * @retval void
 */
static void sci_init_port( void )
{
	// TXD1 : P26
	// RXD1 : P30

	//PORT2.PDR.BIT.B6 = 0;
	//PORT3.PDR.BIT.B0 = 0;

	//MPC.PWPR.BIT.B0WI  = 0;
	//MPC.PWPR.BIT.PFSWE = 1;

	//MPC.P26PFS.BIT.PSEL = 0x0A;
	//MPC.P30PFS.BIT.PSEL = 0x0A;
			
	//MPC.PWPR.BIT.PFSWE = 0;
    //MPC.PWPR.BIT.B0WI = 1;
			
	PORT2.PMR.BIT.B6 = 1;
	PORT3.PMR.BIT.B0 = 1;
			
	g_sci_rxi_flag = 0;
	g_sci_txi_flag = 0;
	g_sci_err_flag = 0;
	
	//ICU.IER[ IER_SCI1_RXI1 ].BIT.IEN_SCI1_RXI1 = 1;
	//ICU.IPR[ IPR_SCI1_RXI1 ].BIT.IPR = 2;
	

}

/** SciWait֐
 * @param msecF~b
 * @retval void
 */
static void sci_wait( unsigned long msec )
{
	volatile unsigned long i;

	for( i = 0; i < ( 500 * msec ); i++ )
	{
		;
	}
}

/** SCI֐
 * @param void
 * @retval void
 */
void sciInit( void )
{

	sci_init_port();

	//TIE=RIE=TE=RE=1, TEIE=0
	SCI1.SCR.BYTE = 0xf0;

	sci_wait(10);
}

/** o
 * @param 
 * @retval void
 */
void sciWrite( unsigned char Buffer )
{
	
	SCI1.TDR = Buffer;
	
	while( SCI1.SSR.BIT.TEND != 1 )
	{
		;
	}
}

void sciWriteBuf( unsigned char Buffer )
{
	unsigned short next_wp;
	
	next_wp = g_sci_buf_wp + 1;
	if(next_wp >= SCI_BUF_SIZE) next_wp = 0;
	
	if(next_wp == g_sci_buf_rp) return;			//obt@tAf[^̊i[͍sȂ
	
	g_sci_buf[g_sci_buf_wp] = Buffer;
	g_sci_buf_wp = next_wp;

}

/** 
 * @param 
 * @retval void
 */
char sciRead( void )
{

	if( g_sci_rxi_flag != 1 )
	{
		return	( char )( ERROR );
	}

	g_sci_rxi_flag = 0;
	
	if( ( SCI1.SSR.BYTE & 0x38 ) != 0 )
	{
		SCI1.SSR.BYTE &= ~0x38;
		return	( char )( ERROR );
	}
	else
	{
		return ( char )( SCI1.RDR );
	}

}

/** o
 * @param |C^
 * @retval void
 */
void sciPrint( char *Buffer )
{
	while( *Buffer != '\0' )
	{
		/* I[o */
		if( *Buffer == '\n' )
		{
			/* so */
			sciWrite( 0x0d );
			sciWrite( 0x0a );
		}
		/* o */
		else
		{
			sciWrite( *Buffer );
		}
		Buffer++;
	}
}

void sciPrintBuf( char *Buffer )
{
	while( *Buffer != '\0' )
	{
		/* I[o */
		if( *Buffer == '\n' )
		{
			/* so */
			sciWriteBuf( 0x0d );
			sciWriteBuf( 0x0a );
		}
		/* o */
		else
		{
			sciWriteBuf( *Buffer );
		}
		Buffer++;
	}
}

/** o(Bytef[^)
 * @param Bytef[^
 * @retval void
 */
void sciPrintByte( unsigned char dmy )
{
	sciWrite( disp_table[ ((dmy & 0xf0) >> 4) ] );
	sciWrite( disp_table[ (dmy & 0x0f) ] );
}

void sciPrintByteBuf( unsigned char dmy )
{
	sciWriteBuf( disp_table[ ((dmy & 0xf0) >> 4) ] );
	sciWriteBuf( disp_table[ (dmy & 0x0f) ] );
}

/** o(WORDf[^)
 * @param WORDf[^
 * @retval void
 */
void sciPrintWord( unsigned short dmy )
{
	unsigned long i;
	char data[2];

	data[1] = (unsigned char)( (dmy & 0x00ff) );
	data[0] = (unsigned char)( (dmy & 0xff00) >> 8 );

	for( i = 0; i < 2; i++ )
	{
		sciWrite( disp_table[ ((data[i] & 0xf0) >> 4) ] );
		sciWrite( disp_table[ (data[i] & 0x0f) ] );
	}
}

void sciPrintWordBuf( unsigned short dmy )
{
	unsigned long i;
	char data[2];

	data[1] = (unsigned char)( (dmy & 0x00ff) );
	data[0] = (unsigned char)( (dmy & 0xff00) >> 8 );

	for( i = 0; i < 2; i++ )
	{
		sciWriteBuf( disp_table[ ((data[i] & 0xf0) >> 4) ] );
		sciWriteBuf( disp_table[ (data[i] & 0x0f) ] );
	}
}

/** o(DWORDf[^)
 * @param DWORDf[^
 * @retval void
 */
void sciPrintDword( unsigned long dmy )
{
	unsigned long i;
	char data[4];

	data[3] = (unsigned char)( dmy & 0x000000ff );
	data[2] = (unsigned char)( (dmy & 0x0000ff00) >> 8 );
	data[1] = (unsigned char)( (dmy & 0x00ff0000) >> 16 );
	data[0] = (unsigned char)( (dmy & 0xff000000) >> 24 );

	for( i = 0; i < 4; i++ )
	{
		sciWrite( disp_table[ ((data[i] & 0xf0) >> 4) ] );
		sciWrite( disp_table[ (data[i] & 0x0f) ] );
	}
}

void sciPrintDwordBuf( unsigned long dmy )
{
	unsigned long i;
	char data[4];

	data[3] = (unsigned char)( dmy & 0x000000ff );
	data[2] = (unsigned char)( (dmy & 0x0000ff00) >> 8 );
	data[1] = (unsigned char)( (dmy & 0x00ff0000) >> 16 );
	data[0] = (unsigned char)( (dmy & 0xff000000) >> 24 );

	for( i = 0; i < 4; i++ )
	{
		sciWriteBuf( disp_table[ ((data[i] & 0xf0) >> 4) ] );
		sciWriteBuf( disp_table[ (data[i] & 0x0f) ] );
	}
}

void sciPrintByteInt( unsigned char dmy )
{
	unsigned char n[5];
	
	n[0] = dmy % 10;
	dmy /= 10;
	n[1] =  dmy % 10;
	dmy /= 10;
	n[2] =  dmy % 10;

	if(n[2] != 0)
	{
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[1] != 0)
	{
		sciWrite( disp_table[n[1]] );
	}

	sciWrite( disp_table[n[0]] );

}

void sciPrintByteIntBuf( unsigned char dmy )
{
	unsigned char n[5];
	
	n[0] = dmy % 10;
	dmy /= 10;
	n[1] =  dmy % 10;
	dmy /= 10;
	n[2] =  dmy % 10;

	if(n[2] != 0)
	{
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[1] != 0)
	{
		sciWriteBuf( disp_table[n[1]] );
	}

	sciWriteBuf( disp_table[n[0]] );
		
}

void sciPrintShortInt( unsigned short dmy )
{
	unsigned char n[5];
	
	n[0] = dmy % 10;
	dmy /= 10;
	n[1] =  dmy % 10;
	dmy /= 10;
	n[2] =  dmy % 10;
	dmy /= 10;
	n[3] =  dmy % 10;
	dmy /= 10;
	n[4] =  dmy % 10;
	
	if(n[4] != 0)
	{
		sciWrite( disp_table[n[4]] );
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[3] != 0)
	{
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[2] != 0)
	{
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[1] != 0)
	{
		sciWrite( disp_table[n[1]] );
	}

	sciWrite( disp_table[n[0]] );
		
}

void sciPrintShortIntBuf( unsigned short dmy )
{
	unsigned char n[5];
	
	n[0] = dmy % 10;
	dmy /= 10;
	n[1] =  dmy % 10;
	dmy /= 10;
	n[2] =  dmy % 10;
	dmy /= 10;
	n[3] =  dmy % 10;
	dmy /= 10;
	n[4] =  dmy % 10;
	
	if(n[4] != 0)
	{
		sciWriteBuf( disp_table[n[4]] );
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[3] != 0)
	{
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[2] != 0)
	{
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[1] != 0)
	{
		sciWriteBuf( disp_table[n[1]] );
	}

	sciWriteBuf( disp_table[n[0]] );
		
}

void sciPrintShortSignedInt( short dmy )
{
	unsigned char n[5];
	long dmy2;
	
	dmy2 = dmy;
	
	if(dmy2 < 0)
	{
		sciWrite('-');
		dmy2 *= -1;
	}
	
	n[0] = dmy2 % 10;
	dmy2 /= 10;
	n[1] =  dmy2 % 10;
	dmy2 /= 10;
	n[2] =  dmy2 % 10;
	dmy2 /= 10;
	n[3] =  dmy2 % 10;
	dmy2 /= 10;
	n[4] =  dmy2 % 10;
	
	if(n[4] != 0)
	{
		sciWrite( disp_table[n[4]] );
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[3] != 0)
	{
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[2] != 0)
	{
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[1] != 0)
	{
		sciWrite( disp_table[n[1]] );
	}

	sciWrite( disp_table[n[0]] );
		
}

void sciPrintShortSignedIntBuf( short dmy )
{
	unsigned char n[5];
	long dmy2;
	
	dmy2 = dmy;
	
	if(dmy2 < 0)
	{
		sciWriteBuf( '-');
		dmy2 *= -1;
	}
	
	n[0] = dmy2 % 10;
	dmy2 /= 10;
	n[1] =  dmy2 % 10;
	dmy2 /= 10;
	n[2] =  dmy2 % 10;
	dmy2 /= 10;
	n[3] =  dmy2 % 10;
	dmy2 /= 10;
	n[4] =  dmy2 % 10;
	
	if(n[4] != 0)
	{
		sciWriteBuf( disp_table[n[4]] );
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[3] != 0)
	{
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[2] != 0)
	{
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[1] != 0)
	{
		sciWriteBuf( disp_table[n[1]] );
	}

	sciWriteBuf( disp_table[n[0]] );
		
}

void sciPrintLongInt( unsigned long dmy )
{
	unsigned char n[10];
	
	n[0] = dmy % 10;
	dmy /= 10;
	n[1] =  dmy % 10;
	dmy /= 10;
	n[2] =  dmy % 10;
	dmy /= 10;
	n[3] =  dmy % 10;
	dmy /= 10;
	n[4] =  dmy % 10;
	dmy /= 10;
	n[5] =  dmy % 10;
	dmy /= 10;
	n[6] =  dmy % 10;
	dmy /= 10;
	n[7] =  dmy % 10;
	dmy /= 10;
	n[8] =  dmy % 10;
	dmy /= 10;
	n[9] =  dmy % 10;
	
	if(n[9] != 0)
	{
		sciWrite( disp_table[n[9]] );
		sciWrite( disp_table[n[8]] );
		sciWrite( disp_table[n[7]] );
		sciWrite( disp_table[n[6]] );
		sciWrite( disp_table[n[5]] );
		sciWrite( disp_table[n[4]] );
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[8] != 0)
	{
		sciWrite( disp_table[n[8]] );
		sciWrite( disp_table[n[7]] );
		sciWrite( disp_table[n[6]] );
		sciWrite( disp_table[n[5]] );
		sciWrite( disp_table[n[4]] );
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[7] != 0)
	{
		sciWrite( disp_table[n[7]] );
		sciWrite( disp_table[n[6]] );
		sciWrite( disp_table[n[5]] );
		sciWrite( disp_table[n[4]] );
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[6] != 0)
	{
		sciWrite( disp_table[n[6]] );
		sciWrite( disp_table[n[5]] );
		sciWrite( disp_table[n[4]] );
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[5] != 0)
	{
		sciWrite( disp_table[n[5]] );
		sciWrite( disp_table[n[4]] );
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[4] != 0)
	{
		sciWrite( disp_table[n[4]] );
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[3] != 0)
	{
		sciWrite( disp_table[n[3]] );
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[2] != 0)
	{
		sciWrite( disp_table[n[2]] );
		sciWrite( disp_table[n[1]] );
	}
	else if(n[1] != 0)
	{
		sciWrite( disp_table[n[1]] );
	}

	sciWrite( disp_table[n[0]] );
		
}

void sciPrintLongIntBuf( unsigned long dmy )
{
	unsigned char n[10];
	
	n[0] = dmy % 10;
	dmy /= 10;
	n[1] =  dmy % 10;
	dmy /= 10;
	n[2] =  dmy % 10;
	dmy /= 10;
	n[3] =  dmy % 10;
	dmy /= 10;
	n[4] =  dmy % 10;
	dmy /= 10;
	n[5] =  dmy % 10;
	dmy /= 10;
	n[6] =  dmy % 10;
	dmy /= 10;
	n[7] =  dmy % 10;
	dmy /= 10;
	n[8] =  dmy % 10;
	dmy /= 10;
	n[9] =  dmy % 10;
	
	if(n[9] != 0)
	{
		sciWriteBuf( disp_table[n[9]] );
		sciWriteBuf( disp_table[n[8]] );
		sciWriteBuf( disp_table[n[7]] );
		sciWriteBuf( disp_table[n[6]] );
		sciWriteBuf( disp_table[n[5]] );
		sciWriteBuf( disp_table[n[4]] );
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[8] != 0)
	{
		sciWriteBuf( disp_table[n[8]] );
		sciWriteBuf( disp_table[n[7]] );
		sciWriteBuf( disp_table[n[6]] );
		sciWriteBuf( disp_table[n[5]] );
		sciWriteBuf( disp_table[n[4]] );
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[7] != 0)
	{
		sciWriteBuf( disp_table[n[7]] );
		sciWriteBuf( disp_table[n[6]] );
		sciWriteBuf( disp_table[n[5]] );
		sciWriteBuf( disp_table[n[4]] );
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[6] != 0)
	{
		sciWriteBuf( disp_table[n[6]] );
		sciWriteBuf( disp_table[n[5]] );
		sciWriteBuf( disp_table[n[4]] );
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[5] != 0)
	{
		sciWriteBuf( disp_table[n[5]] );
		sciWriteBuf( disp_table[n[4]] );
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[4] != 0)
	{
		sciWriteBuf( disp_table[n[4]] );
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[3] != 0)
	{
		sciWriteBuf( disp_table[n[3]] );
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[2] != 0)
	{
		sciWriteBuf( disp_table[n[2]] );
		sciWriteBuf( disp_table[n[1]] );
	}
	else if(n[1] != 0)
	{
		sciWriteBuf( disp_table[n[1]] );
	}

	sciWriteBuf( disp_table[n[0]] );
		
}
/* End of File */
